//+------------------------------------------------------------------+
//|MTF NonLagMAv7.1_4TF_Bar  based on    MTF_MegaTrend_Bar_4TFNextM5 | 
//|                 from STEINITZ lee_yan_cn mod N4TF HAS Bar.mq4    |
//|                  Modified by Matsu, from #MTF Supertrend Bar.mq4 |
//| Forex-TSD.com                        Copyright  2006, Eli hayun |
//|                                          http://www.elihayun.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Eli hayun"
#property link      "http://www.elihayun.com"

#property indicator_separate_window
#property indicator_minimum -1
#property indicator_maximum 2.5
#property indicator_buffers 8
#property indicator_color1 LimeGreen
#property indicator_color2 Red
#property indicator_color3 LimeGreen
#property indicator_color4 Red
#property indicator_color5 LimeGreen
#property indicator_color6 Red
#property indicator_color7 LimeGreen
#property indicator_color8 Red
/*
extern int		Period_1       = 7;
extern int		Period_2       = 21;
extern int		Period_3       = 84;
extern int		Period_4       = 336;
extern int		Price          = 0;
*/
extern string Indic_Name1     = "RK-ml-XO clean for HA";
extern string XO_4Pds_input   ="4 BoxPeriods";
extern double BoxPeriod1      = 1;
extern double BoxPeriod2      = 2;
extern double BoxPeriod3      = 3;
extern double BoxPeriod4      = 4;
extern bool   XOcleanForHA_On     = TRUE;
extern ENUM_MA_METHOD haMaMetod   = MODE_SMMA;
extern int            haMaPeriod  = 6;
extern ENUM_MA_METHOD haMaMetod2  = MODE_LWMA;
extern int            haMaPeriod2 = 2;

extern int		BarWidth       = 0;
extern color	BarColorUp     = LimeGreen;
extern color	BarColorDown   = Red;
extern color	TextColor      = Gray;
extern bool		MTF_Hi_to_Lo   = true;
extern bool		ShowArrows     = true;
extern color	UpArrowColor   = LimeGreen;
extern color	DownArrowColor = Red;
extern string	Note1          = "Use 2, 3 or 4 dots for arrows";
extern int		DotsforArrow   = 3;
extern bool    alertsOn         = false;    // Turn alerts on?
extern bool    alertsOnCurrent  = true;     // Alerts on current (still opened) bar?
extern bool    alertsMessage    = true;     // Alerts should show pop-up message?
extern bool    alertsPushNotif  = false;    // Alerts should send push notification?
extern bool    alertsSound      = false;    // Alerts should play a sound?
extern bool    alertsEmail      = false;    // Alerts should send email?
extern int     UniqueNum        = 2287;



//---- buffers
double buf1_up[];
double buf1_dn[];
double buf2_up[];
double buf2_dn[];
double buf3_up[];
double buf3_dn[];
double buf4_up[];
double buf4_dn[];
double trend[];
double temp[];

string shortname = "";
int ArrSize = 112;//159;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(9);  
   SetIndexBuffer(0,buf1_up); SetIndexStyle(0,DRAW_ARROW,0,BarWidth,BarColorUp);   SetIndexArrow(0,ArrSize);
   SetIndexBuffer(1,buf1_dn); SetIndexStyle(1,DRAW_ARROW,0,BarWidth,BarColorDown); SetIndexArrow(1,ArrSize);
   SetIndexBuffer(2,buf2_up); SetIndexStyle(2,DRAW_ARROW,0,BarWidth,BarColorUp);   SetIndexArrow(2,ArrSize);
   SetIndexBuffer(3,buf2_dn); SetIndexStyle(3,DRAW_ARROW,0,BarWidth,BarColorDown); SetIndexArrow(3,ArrSize);
   SetIndexBuffer(4,buf3_up); SetIndexStyle(4,DRAW_ARROW,0,BarWidth,BarColorUp);   SetIndexArrow(4,ArrSize);
   SetIndexBuffer(5,buf3_dn); SetIndexStyle(5,DRAW_ARROW,0,BarWidth,BarColorDown); SetIndexArrow(5,ArrSize);
   SetIndexBuffer(6,buf4_up); SetIndexStyle(6,DRAW_ARROW,0,BarWidth,BarColorUp);   SetIndexArrow(6,ArrSize);
   SetIndexBuffer(7,buf4_dn); SetIndexStyle(7,DRAW_ARROW,0,BarWidth,BarColorDown); SetIndexArrow(7,ArrSize);
   SetIndexBuffer(8,trend);
   
	IndicatorDigits(0); DotsforArrow = MathMax(MathMin(DotsforArrow,4),2);
	shortname = "XO-4 ("+BoxPeriod1+","+BoxPeriod2+","+BoxPeriod3+","+BoxPeriod4+","+DotsforArrow+")";
	IndicatorShortName(shortname);
   return(0);
}
int deinit()
{
	for(int i = Bars; i>=0; i--)
	{
		ObjectDelete("Down Arrow"+ Time[i]);
		ObjectDelete("Up Arrow"  + Time[i]);
	}
   for (i=ObjectsTotal()-1; i>-1; i--)
   {
         if (StringFind(ObjectName(i),"FF_"+UniqueNum+"_") >= 0)  ObjectDelete(ObjectName(i));
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         double Gap1,Gap2,Gap3,Gap4;
   
   
   if (MTF_Hi_to_Lo) 
         {Gap1 = 0.5; Gap2 = 1.0; Gap3 = 1.5; Gap4 = 2.0;}
   else  {Gap1 = 2.0; Gap2 = 1.5; Gap3 = 1.0; Gap4 = 0.5;}
   for (int tf=1; tf<=4; tf++)
      {  
         string txt = "??";
         double gp;
         switch (tf)
         {
            case 1: txt = (BoxPeriod1);  gp = Gap1 + 0.1; break;
            case 2: txt = (BoxPeriod2);  gp = Gap2 + 0.1; break;
            case 3: txt = (BoxPeriod3);  gp = Gap3 + 0.1; break;
            case 4: txt = (BoxPeriod4);  gp = Gap4 + 0.1; break;
         }
         string name = "FF_"+UniqueNum+"_"+tf+"_"+txt;
         ObjectCreate(name, OBJ_TEXT, WindowFind(shortname), 0,0);
            ObjectSet(name,OBJPROP_TIME1 ,iTime(NULL,0,0)+_Period*60*3);
            ObjectSet(name,OBJPROP_PRICE1,gp);
            ObjectSetText(name, txt,8,"Arial", TextColor);
      }
   
   
   //
   //
   //
   //
   //
   
	for(int i=limit; i>=0; i--)
	{
		double NonLagPeriod_1p = iCustom(NULL,0,Indic_Name1,BoxPeriod1, XOcleanForHA_On, haMaMetod, haMaPeriod, haMaMetod2,haMaPeriod2,4,1);
		double NonLagPeriod_1c = iCustom(NULL,0,Indic_Name1,BoxPeriod1, XOcleanForHA_On, haMaMetod, haMaPeriod, haMaMetod2,haMaPeriod2,4,0);
		double NonLagPeriod_2p = iCustom(NULL,0,Indic_Name1,BoxPeriod2, XOcleanForHA_On, haMaMetod, haMaPeriod, haMaMetod2,haMaPeriod2,4,1);
		double NonLagPeriod_2c = iCustom(NULL,0,Indic_Name1,BoxPeriod2, XOcleanForHA_On, haMaMetod, haMaPeriod, haMaMetod2,haMaPeriod2,4,0);
		double NonLagPeriod_3p = iCustom(NULL,0,Indic_Name1,BoxPeriod3, XOcleanForHA_On, haMaMetod, haMaPeriod, haMaMetod2,haMaPeriod2,4,1);
		double NonLagPeriod_3c = iCustom(NULL,0,Indic_Name1,BoxPeriod3, XOcleanForHA_On, haMaMetod, haMaPeriod, haMaMetod2,haMaPeriod2,4,0);
		double NonLagPeriod_4p = iCustom(NULL,0,Indic_Name1,BoxPeriod4, XOcleanForHA_On, haMaMetod, haMaPeriod, haMaMetod2,haMaPeriod2,4,1);
		double NonLagPeriod_4c = iCustom(NULL,0,Indic_Name1,BoxPeriod4, XOcleanForHA_On, haMaMetod, haMaPeriod, haMaMetod2,haMaPeriod2,4,0);
		
		/*double NonLagPeriod_1p = iNonLagMa(iMA(NULL,0,1,0,MODE_SMA,Price,i+1),Period_1,i+1,0);
		double NonLagPeriod_1c = iNonLagMa(iMA(NULL,0,1,0,MODE_SMA,Price,i  ),Period_1,i  ,0);
		double NonLagPeriod_2p = iNonLagMa(iMA(NULL,0,1,0,MODE_SMA,Price,i+1),Period_2,i+1,1);
		double NonLagPeriod_2c = iNonLagMa(iMA(NULL,0,1,0,MODE_SMA,Price,i  ),Period_2,i  ,1);
		double NonLagPeriod_3p = iNonLagMa(iMA(NULL,0,1,0,MODE_SMA,Price,i+1),Period_3,i+1,2);
		double NonLagPeriod_3c = iNonLagMa(iMA(NULL,0,1,0,MODE_SMA,Price,i  ),Period_3,i  ,2);
		double NonLagPeriod_4p = iNonLagMa(iMA(NULL,0,1,0,MODE_SMA,Price,i+1),Period_4,i+1,3);
		double NonLagPeriod_4c = iNonLagMa(iMA(NULL,0,1,0,MODE_SMA,Price,i  ),Period_4,i  ,3);
		*/
		
		
		
		
		
		
		
		   buf1_up[i] = buf1_up[i+1]; buf1_dn[i] = buf1_dn[i+1];
		   buf2_up[i] = buf2_up[i+1]; buf2_dn[i] = buf2_dn[i+1];
		   buf3_up[i] = buf3_up[i+1]; buf3_dn[i] = buf3_dn[i+1];
		   buf4_up[i] = buf4_up[i+1]; buf4_dn[i] = buf4_dn[i+1];
		   trend[i]   = trend[i+1];
		   int scoreup = 0; int scoredn = 0;
		      if	(NonLagPeriod_1c > NonLagPeriod_1p)	{ buf1_up[i] = Gap1; buf1_dn[i] = EMPTY_VALUE; if (DotsforArrow>=1) scoreup++;}
		      if	(NonLagPeriod_1c < NonLagPeriod_1p)	{ buf1_dn[i] = Gap1; buf1_up[i] = EMPTY_VALUE; if (DotsforArrow>=1) scoredn--;}
		      if	(NonLagPeriod_2c > NonLagPeriod_2p)	{ buf2_up[i] = Gap2; buf2_dn[i] = EMPTY_VALUE; if (DotsforArrow>=2) scoreup++;}
		      if	(NonLagPeriod_2c < NonLagPeriod_2p)	{ buf2_dn[i] = Gap2; buf2_up[i] = EMPTY_VALUE; if (DotsforArrow>=2) scoredn--;}
		      if	(NonLagPeriod_3c > NonLagPeriod_3p)	{ buf3_up[i] = Gap3; buf3_dn[i] = EMPTY_VALUE; if (DotsforArrow>=3) scoreup++;}
		      if	(NonLagPeriod_3c < NonLagPeriod_3p)	{ buf3_dn[i] = Gap3; buf3_up[i] = EMPTY_VALUE; if (DotsforArrow>=3) scoredn--;}
		      if	(NonLagPeriod_4c > NonLagPeriod_4p)	{ buf4_up[i] = Gap4; buf4_dn[i] = EMPTY_VALUE; if (DotsforArrow>=4) scoreup++;}
		      if	(NonLagPeriod_4c < NonLagPeriod_4p)	{ buf4_dn[i] = Gap4; buf4_up[i] = EMPTY_VALUE; if (DotsforArrow>=4) scoredn--;}
		      if (scoreup>= DotsforArrow) trend[i] =  1;
		      if (scoredn<=-DotsforArrow) trend[i] = -1;
	         if(ShowArrows)
	         {
		         ObjectDelete("Down Arrow"+ Time[i]);
		         ObjectDelete("Up Arrow"  + Time[i]);
		         if (trend[i]!=trend[i+1])
		         {
     					double ArrowGap = 0.5*MathCeil(iATR(NULL,0,14,i)/Point);
      				if(trend[i] == -1)
				      {
   			         ObjectCreate("Down Arrow"+Time[i],OBJ_ARROW,0, Time[i],High[i]+ArrowGap*Point);
				            ObjectSet("Down Arrow"+Time[i],OBJPROP_ARROWCODE,234);
				            ObjectSet("Down Arrow"+Time[i],OBJPROP_COLOR,DownArrowColor);
				      }
      				if(trend[i] ==  1)
				      {
			      		ObjectCreate("Up Arrow"+Time[i],OBJ_ARROW,0, Time[i],Low[i]-ArrowGap*Point);
         					ObjectSet("Up Arrow"+Time[i],OBJPROP_ARROWCODE,233);
			         		ObjectSet("Up Arrow"+Time[i],OBJPROP_COLOR,UpArrowColor);
      				}
		         }
		      }
   }
   manageAlerts();
	return(0);
}


//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar+1]==-1) doAlert(whichBar,"nlma mp trend changed to up");
         if (trend[whichBar+1]== 1) doAlert(whichBar,"nlma mp trend changed to down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message = TimeFrameToString(_Period)+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" "+doWhat;
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(StringConcatenate(Symbol()," nlma mp "),message);
          if (alertsPushNotif) SendNotification(StringConcatenate(Symbol()," nlma mp "+message));
          if (alertsSound)     PlaySound("alert2.wav");
   }
}

//
//
//
//
//

string TimeFrameToString(int tf)
{
	string tfs;
	switch(tf)
	{
		case PERIOD_M1:  tfs="M1"  ; break;
		case PERIOD_M5:  tfs="M5"  ; break;
		case PERIOD_M15: tfs="M15" ; break;
		case PERIOD_M30: tfs="M30" ; break;
		case PERIOD_H1:  tfs="H1"  ; break;
		case PERIOD_H4:  tfs="H4"  ; break;
		case PERIOD_D1:  tfs="D1"  ; break;
		case PERIOD_W1:  tfs="W1"  ; break;
		case PERIOD_MN1: tfs="MN";
	}
	return(tfs);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

#define Pi       3.14159265358979323846264338327950288
#define _length  0
#define _len     1
#define _weight  2

double  nlmvalues[4][3];
double  nlmprices[ ][4];
double  nlmalphas[ ][4];

//
//
//
//
//

double iNonLagMa(double price, double length, int r, int instanceNo=0)
{
   if (ArrayRange(nlmprices,0) != Bars)       ArrayResize(nlmprices,Bars); r=Bars-r-1;
   if (ArrayRange(nlmvalues,0) <  instanceNo) ArrayResize(nlmvalues,instanceNo);
                               nlmprices[r][instanceNo]=price;
   if (length<3 || r<3) return(nlmprices[r][instanceNo]);
   
   //
   //
   //
   //
   //
   
   if (nlmvalues[instanceNo][_length] != length  || ArraySize(nlmalphas)==0)
   {
      double Cycle = 4.0;
      double Coeff = 3.0*Pi;
      int    Phase = length-1;
      
         nlmvalues[instanceNo][_length] = length;
         nlmvalues[instanceNo][_len   ] = length*4 + Phase;  
         nlmvalues[instanceNo][_weight] = 0;

         if (ArrayRange(nlmalphas,0) < nlmvalues[instanceNo][_len]) ArrayResize(nlmalphas,nlmvalues[instanceNo][_len]);
         for (int k=0; k<nlmvalues[instanceNo][_len]; k++)
         {
            if (k<=Phase-1) 
                 double t = 1.0 * k/(Phase-1);
            else        t = 1.0 + (k-Phase+1)*(2.0*Cycle-1.0)/(Cycle*length-1.0); 
            double beta = MathCos(Pi*t);
            double g = 1.0/(Coeff*t+1); if (t <= 0.5 ) g = 1;
      
            nlmalphas[k][instanceNo]        = g * beta;
            nlmvalues[instanceNo][_weight] += nlmalphas[k][instanceNo];
         }
   }
   
   //
   //
   //
   //
   //
   
   if (nlmvalues[instanceNo][_weight]>0)
   {
      double sum = 0;
           for (k=0; k < nlmvalues[instanceNo][_len]; k++) sum += nlmalphas[k][instanceNo]*nlmprices[r-k][instanceNo];
           return( sum / nlmvalues[instanceNo][_weight]);
   }
   else return(0);           
}